Index: loader/source/menu.c
===================================================================
--- loader/source/menu.c	(revision 542)
+++ loader/source/menu.c	(working copy)
@@ -32,18 +32,18 @@
 #include <unistd.h>
 #include <ogc/stm.h>
 #include <ogc/video.h>
-#include <ogc/video_types.h>
-#include <ogc/consol.h>
-#include <ogc/system.h>
-//#include <fat.h>
-#include <di/di.h>
-#include "menu.h"
-#include "../../common/include/CommonConfigStrings.h"
-
-#include "ff_utf8.h"
-
-// Device state.
-typedef enum {
+#include <ogc/video_types.h>
+#include <ogc/consol.h>
+#include <ogc/system.h>
+#include <fat.h>
+#include <di/di.h>
+#include "../../common/include/CommonConfigStrings.h"
+#include "menu.h"
+#include "ff_utf8.h"
+#include "diskio.h"
+
+// Device state.
+typedef enum {
 	// Device is open and has a "games" directory.
 	DEV_OK = 0,
 	// Device could not be opened.
@@ -57,12 +57,14 @@
  * Print information about the selected device.
  */
 static void PrintDevInfo(void);
-
-extern NIN_CFG* ncfg;
-
-u32 Shutdown = 0;
-extern char *launch_dir;
-
+
+extern NIN_CFG* ncfg;
+
+extern int ExitBoot;
+
+u32 Shutdown = 0;
+extern char *launch_dir;
+
 inline u32 SettingY(u32 row)
 {
 	return 127 + 16 * row;
@@ -115,27 +117,28 @@
  * @return DevState value:
  * - DEV_OK: Device opened and has a "games/" directory.
  * - DEV_NO_OPEN: Could not open the storage device.
- * - DEV_NO_GAMES: No "games/" directory was found.
- */
-static DevState LoadGameList(gameinfo *gi, u32 sz, u32 *pGameCount)
-{
-	// Create a list of games
-	char filename[MAXPATHLEN];	// Current filename.
-	char gamename[65];		// Game title.
-	char buf[0x100];		// Disc header.
-	int gamecount = 0;		// Current game count.
-
-	if( !IsWiiU() )
-	{
-		// Pseudo game for booting a GameCube disc on Wii.
+ * - DEV_NO_GAMES: No "games/" directory was found.
+ */
+static DevState LoadGameList(gameinfo *gi, u32 sz, u32 *pGameCount)
+{	
+	// Create a list of games
+	char filename[MAXPATHLEN];	// Current filename.
+	char gamename[65];		// Game title.
+	char buf[0x100];		// Disc header.
+	int gamecount = 0;		// Current game count.
+
+
+	if( !IsWiiU() )
+	{
+		// Pseudo game for booting a GameCube disc on Wii.
 		gi[0].ID[0] = 'D',gi[0].ID[1] = 'I',gi[0].ID[2] = 'S';
-		gi[0].ID[3] = 'C',gi[0].ID[4] = '0',gi[0].ID[5] = '1';
-		gi[0].Name = "Boot GC Disc in Drive";
-		gi[0].NameAlloc = 0;
-		gi[0].DiscNumber = 0;
-		gi[0].Path = strdup("di:di");
-		gamecount++;
-	}
+		gi[0].ID[3] = 'C',gi[0].ID[4] = '0',gi[0].ID[5] = '1';
+		gi[0].Name = "Boot GC Disc in Drive";
+		gi[0].NameAlloc = 0;
+		gi[0].DiscNumber = 0;		
+		gi[0].Path = strdup("di:di");
+		gamecount++;
+	}
 
 	DIR pdir;
 	snprintf(filename, sizeof(filename), "%s:/games", GetRootDevice());
@@ -159,20 +162,20 @@
 		f_closedir(&pdir);
 		if (pGameCount)
 			*pGameCount = gamecount;
-		return DEV_NO_GAMES;
-	}
-
-	// Process the directory.
-	// TODO: chdir into /games/?
-	FILINFO fInfo;
-	FIL in;
-	while (f_readdir(&pdir, &fInfo) == FR_OK && fInfo.fname[0] != '\0')
-	{
-		// Game layout should be: /games/GAMEID/game.iso
-		// Search for subdirectories.
-		if (fInfo.fattrib & AM_DIR)
-		{
-			// Skip "." and "..".
+		return DEV_NO_GAMES;
+	}
+
+	// Process the directory.	
+	// TODO: chdir into /games/?
+	FILINFO fInfo;
+	FIL in;
+	while (f_readdir(&pdir, &fInfo) == FR_OK && fInfo.fname[0] != '\0')
+	{
+		// Game layout should be: /games/GAMEID/game.iso
+		// Search for subdirectories.	
+		if (fInfo.fattrib & AM_DIR)
+		{
+			// Skip "." and "..".
 			// This will also skip "hidden" directories.
 			if (fInfo.fname[0] == '.')
 				continue;
@@ -182,21 +185,21 @@
 			// NOTE: fInfo.fname[] is UTF-16.
 			const char *filename_utf8 = wchar_to_char(fInfo.fname);
 			int fnlen = snprintf(filename, sizeof(filename), "%s:/games/%s/",
-					     GetRootDevice(), filename_utf8);
-
-			//Test if game.iso exists and add to list
-			bool found = false;
-			u32 DiscNumber;
-			for (DiscNumber = 0; DiscNumber < 2; DiscNumber++)
+					     GetRootDevice(), filename_utf8);
+
+			//Test if game.iso exists and add to list
+
+			bool found = false;
+			u32 DiscNumber;
+			for (DiscNumber = 0; DiscNumber < 2; DiscNumber++)
 			{
 				if (DiscNumber)
-					memcpy(&filename[fnlen], "disc2.iso", 10);
-				else
-					memcpy(&filename[fnlen], "game.iso", 9);
-
-				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
-				{
-					// Read the disc header
+					memcpy(&filename[fnlen], "disc2.iso", 10);
+				else
+					memcpy(&filename[fnlen], "game.iso", 9);
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+					// Read the disc header
 					//gprintf("(%s) ok\n", filename );
 					UINT read;
 					f_read(&in, buf, 0x100, &read);
@@ -235,52 +238,50 @@
 			// If game.iso wasn't found, check for FST format.
 			if (!found)
 			{
-				memcpy(&filename[fnlen], "sys/boot.bin", 13);
-				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
-				{
-					//gprintf("(%s) ok\n", filename );
-					UINT read;
-					f_read(&in, buf, 0x100, &read);
-					f_close(&in);
+				memcpy(&filename[fnlen], "sys/boot.bin", 13);
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+				//	gprintf("(%s) ok\n", filename );
+					UINT read;
+					f_read(&in, buf, 0x100, &read);
+					f_close(&in);
 
 					if (read == 0x100 && IsGCGame((u8*)buf))	// Must be GC game
-					{
-						// Terminate the filename at the game's base directory.
-						filename[fnlen] = 0;
-
-						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
-						gi[gamecount].DiscNumber = DiscNumber;
-
+					{
+						// Terminate the filename at the game's base directory.
+						filename[fnlen] = 0;
+ 
+						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
+						gi[gamecount].DiscNumber = DiscNumber;
+
 						// TODO: Check titles.txt?
 						strncpy(gamename, buf + 0x20, sizeof(gamename)-1);
-						gamename[sizeof(gamename)-1] = 0;
-						gi[gamecount].Name = strdup(gamename);
-						gi[gamecount].NameAlloc = 1;
-
-						gi[gamecount].Path = strdup( filename );
-						gamecount++;
-					}
+						gamename[sizeof(gamename)-1] = 0;
+						gi[gamecount].Name = strdup(gamename);
+						gi[gamecount].NameAlloc = 1;
+						
+						gi[gamecount].Path = strdup( filename );
+						gamecount++;
+					}
 				}
 			}
 		}
 
 		if (gamecount >= sz)	//if array is full
-			break;
-	}
-	f_closedir(&pdir);
+			break;
+	}
+	f_closedir(&pdir);
+	// Sort the list alphabetically.
+	// On Wii, the pseudo-entry for GameCube discs is always
+	// kept at the top.	
+	if( IsWiiU() )
+		qsort(gi, gamecount, sizeof(gameinfo), compare_names);
+	else if( gamecount > 1 )
+		qsort(&gi[1], gamecount-1, sizeof(gameinfo), compare_names);
+	// Save the game count.
+	if (pGameCount)
+		*pGameCount = gamecount;
 
-	// Sort the list alphabetically.
-	// On Wii, the pseudo-entry for GameCube discs is always
-	// kept at the top.
-	if( IsWiiU() )
-		qsort(gi, gamecount, sizeof(gameinfo), compare_names);
-	else if( gamecount > 1 )
-		qsort(&gi[1], gamecount-1, sizeof(gameinfo), compare_names);
-
-	// Save the game count.
-	if (pGameCount)
-		*pGameCount = gamecount;
-
 	return DEV_OK;
 }
 
@@ -296,13 +297,38 @@
 {
 	// Create a list of games
 	char filename[MAXPATHLEN];
-
-	// Depending on how many games are on the storage device,
-	// this could take a while.
-	ShowLoadingScreen();
-
-	// Load the game list.
-	u32 gamecount = 0;
+
+	// Depending on how many games are on the storage device,
+	// this could take a while.
+	//ShowLoadingScreen();
+		ClearScreen();
+		BackTheme();
+		if (which_bg == BG_NONE)
+		{
+		PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Loading, please wait...");
+		}
+		else if (which_bg == BG_LEGACY)
+		{
+		PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Loading, please wait...");
+		}
+		else
+		{
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 230, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 408, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 408, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 228, MENU_POS_Y + 410, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, BLACK, 232, MENU_POS_Y + 406, "Loading, please wait...");
+		PrintFormat(DEFAULT_SIZE, WHITE, 230, MENU_POS_Y + 408, "Loading, please wait...");		
+		}
+		GRRLIB_Render();
+		sleep (1);
+		ClearScreen();
+
+	// Load the game list.
+	u32 gamecount = 0;
 	gameinfo gi[MAX_GAMES];
 
 	devState = LoadGameList(&gi[0], MAX_GAMES, &gamecount);
@@ -343,13 +369,13 @@
 
 	u32 ListMax = gamecount;
 	if( ListMax > 15 )
-		ListMax = 15;
-	bool SaveSettings = false;
-
-	// set default game to game that currently set in configuration
-	for (i = 0; i < gamecount; ++i)
-	{
-		if (strcasecmp(strchr(gi[i].Path,':')+1, ncfg->GamePath) == 0)
+		ListMax = 15;
+	bool SaveSettings = false;
+
+//	set default game to game that currently set in configuration
+	for (i = 0; i < gamecount; ++i)
+	{
+		if (strcasecmp(strchr(gi[i].Path,':')+1, ncfg->GamePath) == 0)
 		{
 			if( i >= ListMax )
 			{
@@ -358,25 +384,27 @@
 			} else {
 				PosX = i;
 			}
-			break;
-		}
-	}
-
-	u32 UpHeld = 0, DownHeld = 0;
-	while(1)
-	{
+			break;
+		}
+	}
+	UpdateScreen();
+	u32 UpHeld = 0, DownHeld = 0;
+	while(1)
+	{
 		VIDEO_WaitVSync();
 		FPAD_Update();
 
 		if( FPAD_Start(1) )
+		{
+			// Go back to the Settings menu.
+			selected = false;
+			//break;
+			ExitBoot = 0;
+			SelectDevAndGame();	
+		}
+
+		if( FPAD_Cancel(0) )
 		{
-			// Go back to the Settings menu.
-			selected = false;
-			break;
-		}
-
-		if( FPAD_Cancel(0) )
-		{
 			MenuMode ^= 1;
 
 			if( MenuMode == 0 )
@@ -386,13 +414,13 @@
 					ListMax = 15;
 				PosX = prevPosX;
 				ScrollX = prevScrollX;
-			}
-			else
-			{
-				ListMax = NIN_SETTINGS_LAST;
-
-				prevPosX = PosX;
-				PosX	= 0;
+			}
+			else
+			{
+				ListMax = (NIN_SETTINGS_LAST - 1);
+
+				prevPosX = PosX;
+				PosX	= 0;
 				prevScrollX = ScrollX;
 				ScrollX = 0;
 				settingPart = 0;
@@ -402,18 +430,32 @@
 		}
 
 	//	gprintf("\rS:%u P:%u G:%u M:%u    ", ScrollX, PosX, gamecount, ListMax );
-
-		if( MenuMode == 0 )		//game select menu
-		{
-			if( FPAD_Down(1) )
-			{
-				if(DownHeld == 0 || DownHeld > 10)
-				{
-					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
-
-					if( PosX + 1 >= ListMax )
-					{
-						if( PosX + 1 + ScrollX < gamecount)
+
+		if( MenuMode == 0 )		//game select menu
+		{
+			if(FPAD_X(0)) {				
+				UpdateNintendont();
+				redraw = 1;
+			}
+			if(FPAD_Y(0)) {
+				Credits();
+				redraw = 1;
+			}			
+			if( FPAD_Down(1) )
+			{
+				if(DownHeld == 0 || DownHeld > 10)
+				{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}					
+					if( PosX + 1 >= ListMax )
+					{
+						if( PosX + 1 + ScrollX < gamecount)
 							ScrollX++;
 						else {
 							PosX	= 0;
@@ -431,14 +473,20 @@
 				DownHeld++;
 			}
 			else
-				DownHeld = 0;
-			if( FPAD_Right(0) )
-			{
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
-
-				if( PosX == ListMax - 1 )
-				{
-					if( PosX + ListMax + ScrollX < gamecount)
+				DownHeld = 0;
+			if( FPAD_Right(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}	
+				if( PosX == ListMax - 1 )
+				{
+					if( PosX + ListMax + ScrollX < gamecount)
 						ScrollX = ScrollX + ListMax;
 					else
 					if( PosX + ScrollX != gamecount -1)
@@ -453,18 +501,24 @@
 			
 				if((ncfg->Config & NIN_CFG_CHEATS) && (ncfg->Config & NIN_CFG_CHEAT_PATH))	//if cheat path being used
 					ncfg->Config = ncfg->Config & ~(NIN_CFG_CHEATS | NIN_CFG_CHEAT_PATH);		//clear it beacuse it cant be correct for a different game
-				redraw=1;
-				SaveSettings = true;
-			}
-			else if( FPAD_Up(1) )
-			{
-				if(UpHeld == 0 || UpHeld > 10)
-				{
-					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
-
-					if( PosX <= 0 )
-					{
-						if( ScrollX > 0 )
+				redraw=1;
+				SaveSettings = true;
+			}
+			if( FPAD_Up(1) )
+			{
+				if(UpHeld == 0 || UpHeld > 10)
+				{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}	
+					if( PosX <= 0 )
+					{
+						if( ScrollX > 0 )
 							ScrollX--;
 						else {
 							PosX	= ListMax - 1;
@@ -482,14 +536,20 @@
 				UpHeld++;
 			}
 			else
-				UpHeld = 0;
-			if( FPAD_Left(0) )
-			{
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
-
-				if( PosX == 0 )
-				{
-					if( ScrollX - (s32)ListMax >= 0 )
+				UpHeld = 0;
+			if( FPAD_Left(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " ");
+					}	
+				if( PosX == 0 )
+				{
+					if( ScrollX - (s32)ListMax >= 0 )
 						ScrollX = ScrollX - ListMax;
 					else
 					if( ScrollX != 0 )
@@ -506,24 +566,40 @@
 				redraw=1;
 				SaveSettings = true;
 			}
-
-			if( FPAD_OK(0) )
-			{
-				// User selected a game.
-				selected = true;
-				break;
-			}
-
-			if( redraw )
-			{
-				PrintInfo();
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*0, "Home: Go Back");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "A   : %s", MenuMode ? "Modify" : "Select");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "B   : %s", MenuMode ? "Game List" : "Settings ");
-				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*3, MenuMode ? "X/1 : Update" : "");
-				PrintDevInfo();
-
-				// Starting position.
+
+			if( FPAD_OK(0) )
+			{
+				{
+				GRRLIB_FillScreen (BLACK);
+				// User selected a game.
+				selected = true;
+				break;
+				}
+			}
+
+			if( redraw )
+			{
+				PrintInfo();
+					if (which_bg == BG_NONE)
+					{
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Device");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : %s", MenuMode ? "Modify" : "Select");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : %s", MenuMode ? "Game List" : "Settings ");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "X / 1 : Updates & Themes");
+				PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Device");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : %s", MenuMode ? "Modify" : "Select");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : %s", MenuMode ? "Game List" : "Settings ");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "X / 1 : Updates & Themes");
+				PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}		
+								
+				PrintDevInfo();
+
+				// Starting position.
 				int gamelist_y = MENU_POS_Y + 20*4;
 				if (devState != DEV_OK)
 				{
@@ -537,72 +613,117 @@
 					// FIXME: Print all 64 characters of the game name?
 					// Currently truncated to 50.
 					const gameinfo *cur_gi = &gi[i+ScrollX];
-					if (cur_gi->DiscNumber == 0)
-					{
-						// Disc 1.
-						PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, gamelist_y,
-							    "%50.50s [%.6s]%s",
-							    cur_gi->Name, cur_gi->ID,
-							    i == PosX ? ARROW_LEFT : " ");
-					}
-					else
-					{
-						// Disc 2 or higher.
-						PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, gamelist_y,
-							    "%46.46s (%d) [%.6s]%s",
-							    cur_gi->Name, cur_gi->DiscNumber+1, cur_gi->ID,
-							    i == PosX ? ARROW_LEFT : " ");
-					}
-				}
-				GRRLIB_Render();
-				Screenshot();
+					if (cur_gi->DiscNumber == 0)
+					{
+						// Disc 1.
+					if (which_bg == BG_NONE)
+					{
+			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, gamelist_y,
+							    "%50.50s [%.6s]%s",
+							    cur_gi->Name, cur_gi->ID,
+							    i == PosX ? ARROW_LEFT : " ");			
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, gamelist_y,
+								"%50.50s [%.6s]%s",
+							    cur_gi->Name, cur_gi->ID,
+							    i == PosX ? ARROW_LEFT : " ");	
+					}
+					}
+					else
+					{
+						// Disc 2 or higher.
+					if (which_bg == BG_NONE)
+					{
+						PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, gamelist_y,
+							    "%46.46s (%d) [%.6s]%s",
+							    cur_gi->Name, cur_gi->DiscNumber+1, cur_gi->ID,
+							    i == PosX ? ARROW_LEFT : " ");		
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+						PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, gamelist_y,
+							    "%46.46s (%d) [%.6s]%s",
+							    cur_gi->Name, cur_gi->DiscNumber+1, cur_gi->ID,
+							    i == PosX ? ARROW_LEFT : " ");	
+					}
+					}
+				}
+				GRRLIB_Render();
+				Screenshot();
 				ClearScreen();
-				redraw = 0;
-			}
-
-		} else {	//settings menu
-			
-			if(FPAD_X(0)) {
-				UpdateNintendont();
-				redraw = 1;
-			}
-
-			if( FPAD_Down(0) )
-			{
-				if(settingPart == 0)
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+30, SettingY(PosX), " " );
-				else
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+300, SettingY(PosX), " " );
-				PosX++;
-				if(settingPart == 0)
-				{
+				redraw = 0;
+			}
+
+		} else {	//settings menu	
+			if(FPAD_X(0)) {
+				UpdateNintendont();
+				redraw = 1;
+			}
+			if(FPAD_Y(0)) {
+				Credits();
+				redraw = 1;
+			}
+			if( FPAD_Down(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+				if(settingPart == 0)
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+30, SettingY(PosX), " ");
+				else
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+300, SettingY(PosX), " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+				if(settingPart == 0)
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+30, SettingY(PosX), " ");
+				else
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+300, SettingY(PosX), " ");
+					}			
+
+				PosX++;
+				if(settingPart == 0)
+				{
 					if (((ncfg->VideoMode & NIN_VID_FORCE) == 0) && (PosX == NIN_SETTINGS_VIDEOMODE))
 						PosX++;
 					if ((!(ncfg->Config & NIN_CFG_MEMCARDEMU)) && (PosX == NIN_SETTINGS_MEMCARDBLOCKS))
-						PosX++;
-					if ((!(ncfg->Config & NIN_CFG_MEMCARDEMU)) && (PosX == NIN_SETTINGS_MEMCARDMULTI))
-						PosX++;
-				}
-				if ((settingPart == 0 && PosX >= ListMax)
-					|| (settingPart == 1 && PosX >= 3))
+						PosX++;
+					if ((!(ncfg->Config & NIN_CFG_MEMCARDEMU)) && (PosX == NIN_SETTINGS_MEMCARDMULTI))
+						PosX++;
+					//if(PosX == NIN_CFG_BIT_HID) //not needed anymore
+					//	PosX++;
+				}
+				if ((settingPart == 0 && PosX >= ListMax)
+					|| (settingPart == 1 && PosX >= 3))
 				{
 					ScrollX = 0;
 					PosX	= 0;
 					settingPart ^= 1;
 				}
-			
-				redraw=1;
-
-			}
-			else if( FPAD_Up(0) )
-			{
-				if(settingPart == 0)
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+30, SettingY(PosX), " " );
-				else
-					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+300, SettingY(PosX), " " );
-
-				PosX--;
-
+			
+				redraw=1;
+
+			} 
+			if( FPAD_Up(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+				if(settingPart == 0)
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+30, SettingY(PosX), " ");
+				else
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+300, SettingY(PosX), " ");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+				if(settingPart == 0)
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+30, SettingY(PosX), " ");
+				else
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+300, SettingY(PosX), " ");
+					}
+
+				PosX--;
+
 				if (PosX < 0)
 				{
 					settingPart ^= 1;
@@ -616,12 +737,14 @@
 					if ((!(ncfg->Config & NIN_CFG_MEMCARDEMU)) && (PosX == NIN_SETTINGS_MEMCARDMULTI))
 						PosX--;
 					if ((!(ncfg->Config & NIN_CFG_MEMCARDEMU)) && (PosX == NIN_SETTINGS_MEMCARDBLOCKS))
-						PosX--;
-					if (((ncfg->VideoMode & NIN_VID_FORCE) == 0) && (PosX == NIN_SETTINGS_VIDEOMODE))
-						PosX--;
-				}
-				redraw=1;
-			}
+						PosX--;
+					if (((ncfg->VideoMode & NIN_VID_FORCE) == 0) && (PosX == NIN_SETTINGS_VIDEOMODE))
+						PosX--;
+					//if(PosX == NIN_CFG_BIT_HID) //not needed anymore
+					//	PosX--;
+				}
+				redraw=1;
+			}
 
 			if( FPAD_Left(0) )
 			{
@@ -671,14 +794,14 @@
 					}
 					else if(PosX == 1)
 					{
-						ncfg->VideoOffset++;
-						if(ncfg->VideoOffset < -20 || ncfg->VideoOffset > 20)
-							ncfg->VideoOffset = -20;
-						ReconfigVideo(rmode);
-						redraw = 1;
-					}
-				}
-			}
+						ncfg->VideoOffset++;
+						if(ncfg->VideoOffset < -20 || ncfg->VideoOffset > 20)
+							ncfg->VideoOffset = -20;
+					ReconfigVideo(rmode);
+					redraw = 1;					
+					}
+				}
+			}
 
 			if( FPAD_OK(0) )
 			{
@@ -725,13 +848,21 @@
 									Video = NIN_VID_AUTO;
 									break;
 							}
-							ncfg->VideoMode &= ~NIN_VID_MASK;
-							ncfg->VideoMode |= Video;
-							if ((Video & NIN_VID_FORCE) == 0)
-								PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(NIN_SETTINGS_VIDEOMODE), "%29s", "" );
-						} break;
-						case NIN_SETTINGS_VIDEOMODE:
-						{
+							ncfg->VideoMode &= ~NIN_VID_MASK;
+							ncfg->VideoMode |= Video;
+							if ((Video & NIN_VID_FORCE) == 0)
+					{			
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(NIN_SETTINGS_VIDEOMODE), "%29s", "");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(NIN_SETTINGS_VIDEOMODE), "%29s", "");
+					}}
+						} break;
+						case NIN_SETTINGS_VIDEOMODE:
+						{
 							u32 Video = (ncfg->VideoMode & NIN_VID_FORCE_MASK);
 							Video = Video << 1;
 							if (Video > NIN_VID_FORCE_MPAL)
@@ -753,15 +884,23 @@
 						{
 							ncfg->Config ^= (NIN_CFG_NATIVE_SI);
 						} break;
-					}
-					if (!(ncfg->Config & NIN_CFG_MEMCARDEMU))
-					{
-						PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDBLOCKS), "%29s", "");
-						PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDMULTI), "%29s", "");
-					}
-					redraw = 1;
-				}
-				else if(settingPart == 1)
+					}
+					if (!(ncfg->Config & NIN_CFG_MEMCARDEMU))
+					{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDBLOCKS), "%29s", "");
+					PrintFormat(MENU_SIZE, BLACK, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDMULTI), "%29s", "");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDBLOCKS), "%29s", "");
+					PrintFormat(MENU_SIZE, WHITE, MENU_POS_X + 50, SettingY(NIN_SETTINGS_MEMCARDMULTI), "%29s", "");
+					}
+					}
+					redraw = 1;
+				}
+				else if(settingPart == 1)
 				{
 					if(PosX == 2)
 					{
@@ -768,30 +907,57 @@
 						SaveSettings = true;
 						ncfg->VideoMode ^= (NIN_VID_PATCH_PAL50);
 						redraw = 1;
-					}
-				}
-			}
-
-			if( redraw )
-			{
-				u32 ListLoopIndex = 0;
-				for (ListLoopIndex = 0; ListLoopIndex < NIN_CFG_BIT_LAST; ListLoopIndex++)
-				{
-					if(ListLoopIndex == NIN_CFG_BIT_USB) //Option gets replaced
-						PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (NIN_CFG_WIIU_WIDE)) ? "On " : "Off");
-					else
-						PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (1 << ListLoopIndex)) ? "On " : "Off" );
-				}
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%d", OptionStrings[ListLoopIndex], (ncfg->MaxPads));
-				ListLoopIndex++;
-
-				u32 LanIndex = ncfg->Language;
-				if (( LanIndex >= NIN_LAN_LAST ) ||  ( LanIndex < NIN_LAN_FIRST ))
-					LanIndex = NIN_LAN_LAST; //Auto
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-4s", OptionStrings[ListLoopIndex], LanguageStrings[LanIndex] );
-				ListLoopIndex++;
-
-				u32 VideoModeIndex;
+					}
+				}
+			}
+			if( redraw )
+			{
+				u32 ListLoopIndex = 0;
+				for (ListLoopIndex = 0; ListLoopIndex < NIN_CFG_BIT_LAST; ListLoopIndex++)
+				{
+					//if(ListLoopIndex == NIN_CFG_BIT_HID) //not needed anymore
+					//	continue;
+					if(ListLoopIndex == NIN_CFG_BIT_USB) //Option gets replaced
+						{					if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (NIN_CFG_WIIU_WIDE)) ? "On " : "Off");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (NIN_CFG_WIIU_WIDE)) ? "On " : "Off");
+					}}
+					else
+						{					if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (1 << ListLoopIndex)) ? "On " : "Off");					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%s", OptionStrings[ListLoopIndex], (ncfg->Config & (1 << ListLoopIndex)) ? "On " : "Off");					}}
+				}
+									if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%d", OptionStrings[ListLoopIndex], (ncfg->MaxPads));
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex), "%-18s:%d", OptionStrings[ListLoopIndex], (ncfg->MaxPads));
+					}
+				ListLoopIndex++;
+
+				u32 LanIndex = ncfg->Language;
+				if (( LanIndex >= NIN_LAN_LAST ) ||  ( LanIndex < NIN_LAN_FIRST ))
+					LanIndex = NIN_LAN_LAST; //Auto
+										if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-4s", OptionStrings[ListLoopIndex], LanguageStrings[LanIndex] );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-4s", OptionStrings[ListLoopIndex], LanguageStrings[LanIndex] );
+					}
+				ListLoopIndex++;
+
+				u32 VideoModeIndex;
 				u32 VideoModeVal = ncfg->VideoMode & NIN_VID_MASK;
 				switch (VideoModeVal)
 				{
@@ -809,13 +975,21 @@
 						break;
 					default:
 						ncfg->VideoMode &= ~NIN_VID_MASK;
-						ncfg->VideoMode |= NIN_VID_AUTO;
-						VideoModeIndex = NIN_VID_INDEX_AUTO;
-				}
-				PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-18s", OptionStrings[ListLoopIndex], VideoStrings[VideoModeIndex] );
-				ListLoopIndex++;
-
-				if( ncfg->VideoMode & NIN_VID_FORCE )
+						ncfg->VideoMode |= NIN_VID_AUTO;
+						VideoModeIndex = NIN_VID_INDEX_AUTO;
+				}
+					if (which_bg == BG_NONE)
+					{
+PrintFormat(MENU_SIZE, BLACK, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-18s", OptionStrings[ListLoopIndex], VideoStrings[VideoModeIndex] );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+PrintFormat(MENU_SIZE, WHITE, MENU_POS_X+50, SettingY(ListLoopIndex),"%-18s:%-18s", OptionStrings[ListLoopIndex], VideoStrings[VideoModeIndex] );
+					}
+				
+				ListLoopIndex++;
+
+				if( ncfg->VideoMode & NIN_VID_FORCE )
 				{
 					VideoModeVal = ncfg->VideoMode & NIN_VID_FORCE_MASK;
 					u32 VideoTestVal = NIN_VID_FORCE_PAL50;
